/*
 * CustomerTableModel.java
 *
 * Created on February 9, 2006, 2:08 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.customer.model;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.annotation.Resource;
import javax.sql.DataSource;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;

/**
 *
 * @author blaha
 */
public class CustomerTableModel implements TableModel{
    
    @Resource(name="jdbc/__default")
    DataSource ds;
    
    
    private static String[] columnsName = {"ID", "Name", "E-mail"};
    
    ArrayList<Customer> custs = new ArrayList(); 
    
    /** Creates a new instance of CustomerTableModel */
    public CustomerTableModel() {
        readData();
    }

    public int getRowCount() {
        return custs.size();
    }

    public int getColumnCount() {
        return columnsName.length;
    }

    public String getColumnName(int columnIndex) {
        return columnsName[columnIndex];
    }

    public Class<?> getColumnClass(int columnIndex) {
        return String.class;
    }

    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return false;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        String cellValue = "";
        Customer cust = custs.get(rowIndex);
        switch(columnIndex) {
            case 0: cellValue = String.valueOf(cust.getId()); break;
            case 1: cellValue = cust.getName(); break;
            case 2: cellValue = cust.getEmail(); break;
        }
        return cellValue;
    }

    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    }

    public void addTableModelListener(TableModelListener l) {
    }

    public void removeTableModelListener(TableModelListener l) {
    }
    
    public void refreshModel() {
        custs.clear();
        readData();
    }
    
    private void readData() {
        Connection conn = null;
        try{
        conn = ds.getConnection();
        PreparedStatement pStmt = conn.prepareStatement("SELECT CUSTOMER_ID, NAME, EMAIL FROM CUSTOMER");
        ResultSet rs = pStmt.executeQuery();
        while(rs.next()){
            custs.add(new Customer(rs.getInt(1), rs.getString(2), rs.getString(3)));
        }
        }catch(SQLException ex) {
            throw new RuntimeException(ex);
        }finally {
            if(conn != null) {
                try {
                conn.close();
                } catch(SQLException ex) { }
            }
        }
    }
}
